import json
import logging

from reface import const
from reface.line.consumer import LineConsumer


class AddressConsumer(LineConsumer):
    channel_layer_alias = const.ADDRESS_SCANNER

    # Receive message from WebSocket
    def receive(self, text_data=None, bytes_data=None):
        text_data_json = json.loads(text_data)
        try:
            if text_data_json['type'] == 'set_current':
                self.channel_layer.get_worker(*self.dest).set_current(text_data_json['message'])
            elif text_data_json['type'] == 'set_address':
                self.channel_layer.get_worker(*self.dest).set_address(text_data_json['message'])
        except BaseException as ex:
            logging.exception(ex)
