from reface.line.worker import Worker

from resh.utils import settings
from resh.domains import dali1, dali2


class AddressEditor(Worker):
    def __init__(self, *args, **kwargs):
        super(AddressEditor, self).__init__(*args, **kwargs)
        self._current = None

    def _run_thread(self, *args, **kwargs):
        pass

    def send_status(self, channel_name):
        pass

    def set_current(self, data):
        settings.conf.interface = self.box
        if data['type'] == dali1.Dali1Protocol.domain_name:
            cmd = dali1.set_actual_level(self.module, self.channel, data['address'], *data['params'])
        else:
            if isinstance(self._current, dali2.identify):
                self._current.stop()
            cmd = dali2.identify(self.module, self.channel, data['address'], 0)
            self._current = cmd
        cmd.exec()

    def set_address(self, data):
        settings.conf.interface = self.box
        if data['type'] == dali1.Dali1Protocol.domain_name:
            cmd = dali1.swap_short_addresses(self.module, self.channel, data['address'], *data['params'])
        else:
            if isinstance(self._current, dali2.identify):
                self._current.stop()
            cmd = dali2.swap_short_addresses(self.module, self.channel, data['address'], *data['params'])

        cmd.exec()

