import channels.layers


class Layer(channels.layers.InMemoryChannelLayer):
    Worker = None

    def __init__(self, *args, **kwargs):
        super(Layer, self).__init__(*args, **kwargs)
        self._workers = {}

    def get_status(self, box, module, channel, channel_name):
        return self.get_worker(box, module, channel).send_status(channel_name)

    def remove_worker(self, box, module, channel):
        if self.has_worker(box, module, channel):
            self._workers[box][module].pop(channel)

    def has_worker(self, box, module, channel):
        try:
            return int(box) in self._workers \
                   and int(module) in self._workers[box]\
                   and int(channel) in self._workers[box][module]
        except: return False

    def get_worker(self, box, module, channel) -> Worker:
        box = int(box)
        module = int(module)
        channel = int(channel)

        builder = None
        if self.has_worker(box, module, channel):
            return self._workers[box][module][channel]

        if builder is None:
            builder = self.Worker(self, box, module, channel)
            self._workers.setdefault(box, {})
            self._workers[box].setdefault(module, {})
            self._workers[box][module][channel] = builder

        return builder

