import json
import logging

from reface import const
from ..consumer import LineConsumer


class ProbationConsumer(LineConsumer):
    channel_layer_alias = const.LINE_PROBATION

    # Receive message from WebSocket
    def receive(self, text_data=None, bytes_data=None):
        text_data_json = json.loads(text_data)
        try:
            if text_data_json['type'] == 'start':
                self.channel_layer.get_worker(*self.dest).run_thread(text_data_json['message'])
            elif text_data_json['type'] == 'stop':
                self.channel_layer.get_worker(*self.dest).stop_thread()
            else:
                super(ProbationConsumer, self).receive(text_data, bytes_data)
            # elif text_data_json['type'] == 'scan':
            #     self.channel_layer.get_worker(*self.dest).run_thread(text_data_json['message'])
            # elif text_data_json['type'] == 'exec':
            #     self.channel_layer.get_worker(*self.dest).call_command(text_data_json['message'])
            # else:
            #     self.channel_layer.get_worker(*self.dest).set_value(text_data_json['type'], text_data_json['message'])
        except BaseException as ex:
            logging.exception(ex)
