from django.urls import re_path

from reface.line.builder import BuilderConsumer
from reface.line.scanner import ScannerConsumer
from reface.line.address import AddressConsumer
from reface.line.probation import ProbationConsumer
from reface.line.monitor import DaliMonitorConsumer

websocket_urlpatterns = [
    re_path(r'rapida/ws/builder/(?P<box>\d+)/(?P<module>\d+)/(?P<channel>\d+)/$', BuilderConsumer.as_asgi()),
    re_path(r'rapida/ws/scanner/(?P<box>\d+)/(?P<module>\d+)/(?P<channel>\d+)/$', ScannerConsumer.as_asgi()),
    re_path(r'rapida/ws/ordering/(?P<box>\d+)/(?P<module>\d+)/(?P<channel>\d+)/$', AddressConsumer.as_asgi()),
    re_path(r'rapida/ws/probation/(?P<box>\d+)/(?P<module>\d+)/(?P<channel>\d+)/$', ProbationConsumer.as_asgi()),
    re_path(r'rapida/ws/monitor/(?P<box>\d+)/(?P<module>\d+)/(?P<channel>\d+)/dali/$', DaliMonitorConsumer.as_asgi()),
]
