$(document).ready(function () {
    $('#process th').on('click', function (e) {
        const ascending = !e.target.classList.contains('ascended');

        $('th.ascended, th.descended').removeClass('ascended').removeClass('descended');
        $(e.target).addClass(ascending ? 'ascended' : 'descended');

        const tbody = $(e.target).closest(' table').find(' tbody');

        tbody.append(
            tbody.children().not('.header-row').detach().get().sort(function (r1, r2) {
                var v1, v2;
                if (r1.cells[e.target.cellIndex].children.length > 0) {
                    v1 = $(r1.cells[e.target.cellIndex]).find(' input, progress').val();
                    v2 = $(r2.cells[e.target.cellIndex]).find(' input, progress').val();
                    if (v1 === undefined) {
                        v1 = $(r1.cells[e.target.cellIndex]).find(' label').text();
                        v2 = $(r2.cells[e.target.cellIndex]).find(' label').text();
                    }
                } else {

                    v1 = r1.cells[e.target.cellIndex].textContent;
                    v2 = r2.cells[e.target.cellIndex].textContent;
                }

                if (parseFloat(v1) == v1) {
                    v1 = parseFloat(v1);
                    v2 = parseFloat(v2);
                    return (ascending ? 1 : -1) * (v1 > v2 ? 1 : v1===v2 ? 0 : -1);
                }
                return (ascending ? 1 : -1) * v1.localeCompare(v2);
            })
        );
    });

    chatSocket = new WebSocket('ws://' + window.location.host + '/rapida/ws/probation/' + room + '/');

    chatSocket.onclose = function(e) { alert('Соединение с сервером разорвано'); };
    chatSocket.onopen = function() {
        console.log('Opened');
    };
    chatSocket.onmessage = function (e) {
        const data = JSON.parse(e.data);
        if (data.hasOwnProperty('progress')) {
            updateProgress(data.progress);
        } else if (data.hasOwnProperty('result')) {
            $('.selectable-table input[type=checkbox]:checked').prop('checked', false).trigger('change');
            if (data.result) {
                Object.keys(data.result).map(function(dType, i) {
                    Object.keys(data.result[dType]).map(function(address, i) {
                        updateAddress(dType, address, data.result[dType][address]);
                    });
                });
            }
        }
    };

    function updateAddress(dType, address, value) {
        $('#addr-dali'+dType+'-D' + address).prop('checked', true).trigger('change');
        $('#input-dali'+dType+'-' + address).val(parseInt(value)).trigger('change');
    }
});

function setAddress(cb, broadcast) {
    var addresses = [];

    if (broadcast) {
        cb = $(cb).parent().find('input[type=checkbox]')[0];
        cb.checked = !cb.checked;
    }

    $(cb).closest('.selectable-table').find('input[type=checkbox]').each((i, _cb) => {
        if (broadcast) _cb.checked = cb.checked;
        if (_cb.checked) {
            addresses.push(_cb.value);
            $('#input-' + _cb.className + '-' + _cb.value.split('D')[1]).closest('tr').show();
        } else {
            $('#input-' + _cb.className + '-' + _cb.value.split('D')[1]).closest('tr').hide();
        }
    });

    $('input[name=' + cb.className + ']').each((i, input) => { input.value = addresses.join(',') });
    return false;
}

function updateProgress(value) {
    $('#progress').show();
    if (0 < value && value < 100) {
        $('#stop-btn').show();
        $('#start-btn').hide();
    } else {
        $('#stop-btn').hide();
        $('#start-btn').show();
    }
    $('#progress .progress-bar').css('width', value+'%')
        .attr('aria-valuenow', value)[0]
        .textContent = value + '%';
}

function onRangeChanged(input) {
    $('label[for='+input.id+']').text(input.value + '%');
}

function onSubmit(form, start) {
    if (start)
        if (!form.checkValidity())
            return;

    chatSocket.send(
        // console.log(
        JSON.stringify({
            type: start ? 'start' : 'stop',
            message: start ? form2data(form) : {}
        })
    );

    if (start) $('.row-address').hide();
}