from django import template

register = template.Library()


@register.filter(name='multiply', is_safe=False)
def multiply(value, arg):
    """Multiply the arg to the value."""
    try:
        return int(value) * int(arg)
    except (ValueError, TypeError):
        try:
            return value * arg
        except Exception:
            return ''


@register.filter(is_safe=False)
def division(value, arg, r=1):
    """Division the arg by the value."""
    try:
        return round(int(value) / int(arg), int(r))
    except (ValueError, TypeError):
        try:
            return round(value / arg, r)
        except Exception:
            return 0


@register.filter(is_safe=False)
def remnant(value, arg):
    """Division the arg by the value."""
    try:
        return int(value) % int(arg)
    except (ValueError, TypeError):
        try:
            return value % arg
        except Exception:
            return 0


@register.filter(is_safe=False)
def subtract(value, arg):
    """Subtract the arg by the value."""
    try:
        return int(value) - int(arg)
    except (ValueError, TypeError):
        try:
            return value - arg
        except Exception:
            return 0


@register.filter(is_safe=False)
def division_int(value, arg):
    """Division the arg by the value."""
    try:
        return int(value) // int(arg)
    except (ValueError, TypeError):
        try:
            return value / arg
        except Exception:
            return 0


@register.filter(is_safe=False)
def make_range(start, stop):
    return range(start, stop)
