from django import template
from django.template.base import Node

from resh.version import VERSION

register = template.Library()


class VersionNode(Node):
    def render(self, context):
        return VERSION


@register.tag
def version(parser, token):
    return VersionNode()


@register.simple_tag(takes_context=True)
# could feed in additional argument to use as default value
def cookie(context, cookie_name, default=''):
    return context['request'].COOKIES.get(cookie_name, default)


@register.filter(name='split')
def split(value, arg):
    return value.split(arg)
