template = """#!/bin/sh
### BEGIN INIT INFO
# Provides:          {INTERFACE_NAME}.sh
# Required-Start:    $network virtual-can.sh
# Required-Stop:     $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: rcan1 usage script
# Description:       This file should be used to construct scripts to be
#                    placed in /etc/init.d.
### END INIT INFO

DESC="{INTERFACE_NAME} maintenance service"

do_start()
{
    echo "Setting up virtual can ({INTERFACE_NAME})"
    ip link add dev {INTERFACE_NAME} type vcan
    ip link set up {INTERFACE_NAME}
}

do_stop()
{
    echo "Releasing virtual can ({INTERFACE_NAME})"
    ip link set down {INTERFACE_NAME}
    ip link delete dev {INTERFACE_NAME}
}

case "$1" in
    start)
        do_start
        ;;
    stop)
        do_stop
        ;;
    status)
        ip link show {INTERFACE_NAME}
        ;;
    restart|force-reload)
        do_stop
        ;;
    *)
        echo "Usage: {INTERFACE_NAME}.sh {start|stop|status|restart}" >&2
        exit 3
        ;;
esac

exit 0

"""