template = """#!/bin/sh
### BEGIN INIT INFO
# Provides:          virtual-can.sh
# Required-Start:    $local_fs $syslog
# Required-Stop:     $local_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: vcan0 usage script
# Description:       This file should be used to construct scripts to be
#                    placed in /etc/init.d.
### END INIT INFO

DESC="virtual-can maintenance service"

do_start()
{
    echo "Setting up virtual can"
    modprobe vcan
}

do_stop()
{
    echo "Releasing virtual can"
    rmmod vcan
}

case "$1" in
    start)
        do_start
        ;;
    stop)
        do_stop
        ;;
    restart|force-reload)
        do_stop
        ;;
    *)
        echo "Usage: virtual-can.sh {start|stop|restart}" >&2
        exit 3
        ;;
esac

exit 0

"""